/***************************************************************************
 *   Copyright (C) 2005 by s4kk3                                           *
 *   s4kk33@gmail.com                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "dispatch.h"
#include <iostream>
#include <gdk/gdk.h>

using namespace std;

Dispatch *Dispatch::dis	=	NULL;
Dispatch *Dispatch::getInstance()
{ 
	if( !dis )
		dis	=	new Dispatch(); 
	
	return dis; 
}

void *Dispatch::threadFunc( void *arg )
{
	Dispatch *dp	=	(Dispatch*)arg;
	dp->thread();
}

Dispatch::Dispatch()
{	
	queueList	=	g_async_queue_new();

	pthread_create( &dpThread,	NULL,	&threadFunc,	(void*)this );	
}

void Dispatch::thread()
{
	while(1)
	{
		Dp *dp	=	(Dp*)g_async_queue_pop( queueList );

		gdk_threads_enter();
		dp->run();
		gdk_threads_leave();

		delete dp;
	}
}

void Dispatch::addToQueue( Dp *dp )
{
	g_async_queue_push( queueList,	(gpointer)dp );
}
