/***************************************************************************
 *   Copyright (C) 2005 by s4kk3   *
 *   s4kk33@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef PASTEFUNC_HH
#define PASTEFUNC_HH

#include "mainwindow.h"
#include "fileview.h"

enum{
	TYPE_COPY,
	TYPE_CUT,
	TYPE_DELETE,
	TYPE_DOWNLOAD
};

class PasteFunc
{
public:
	PasteFunc(FileView *arg, int type);
	~PasteFunc();

	void pasteThread();
	void pasteFunc(std::string inputPath, std::string outputPath);
	void handleProgressbar();
	void deleteThread();
	void handleProgressStatus();
	void finishPaste();
	void updateProgressbar(double percentage, std::string text);
	void downloadFunc(std::string url);
	void setOutputSize(double size){ outputTotal = size; };

	static void *createPasteThread(void *);
	static void *createDeleteThread(void *);

	int items, p_total;

protected:
	FileView *fv;
	MainWindow *mw;
	GtkWidget *bar, *hBox, *vbox, *cancelButton;
	
	std::ofstream outputFile;
	std::ifstream inputFile;

	std::string pasteData, currentDir, p_input, status, lastFilename, totalSize;
	std::list<std::string> pasteDataList;

	int type;
	unsigned int id;
	double inputSize, inputTotal, lastSize, outputTotal;
};
#else
class PasteFunc;
#endif
