/***************************************************************************
 *   Copyright (C) 2005 by s4kk3   										   *
 *   s4kk33@gmail.com   												   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SETTINGS_HH
#define SETTINGS_HH

#include "mainwindow.h"

enum
{
	COL_ICO,
	COL_MIME,
	COL_ACTION,
	COL_TOGGLE
};

class Settings
{
public:
	~Settings();
	
	static Settings *getInstance( MainWindow *mw	=	NULL );
	
	void	okClicked		( GtkWidget *widget,	gpointer data );
	void	cancelClicked		( GtkWidget *widget,	gpointer data );
	void	editFinished		( GtkCellRenderer *renderer,	gchar *,	gchar *,	gpointer data );
	void	toggled			( GtkCellRendererToggle *cell,	gchar *path,	gpointer data );
	void	scanIconThemes		();
	void	iconThemeSizes		();
	void	downloadClicked		( GtkWidget *widget,	gpointer data );
	void	onDestroyEvent		( GtkWidget *widget,	gpointer data );
	void	scanRunActions		();
	void	loadTabPosition		();
	void	saveTabPosition		();
	void	loadToolbarStyle	();
	void	saveToolbarStyle	();

	int	sizeEntryFindPos	( const std::string& content );
	
protected:
	MainWindow	*mw;
	
	GladeXML	*xml;
	
	GtkWidget		*window;
	GtkButton		*okButton,		*cancelButton,		*applyButton,	*downloadButton;
	GtkEntry		*defPathEntry,		*loginShellEntry;
	GtkSpinButton		*tabsOpened;
	GtkRadioButton		*iconView,		*listView;
	GtkTreeView		*view,			*iconThemeView;
	GtkTreeStore		*store;
	GtkListStore		*iconStore;
	GtkTreeIter		iter;
	GtkRadioButton		*tabsLeft,	*tabsRight,	*tabsBottom,	*tabsTop,	*styleIcons,	*styleText,
				*styleBoth;
	GtkComboBox		*iconSizeEntry;
	GtkBox			*iconOptionsBox;	
	
	Func2<Settings, void, GtkWidget *> cancelCallback, okCallback,	downloadCallback,	destroyCallback;
	Func3<Settings, void, GtkCellRendererToggle *, char *> toggleCallback;
	Func4<Settings, void, GtkCellRenderer *, gchar *, gchar *>	editFinishedCallback;
	
private:
	Settings( MainWindow *mw );
	static Settings *settings;
};
#else 
class Settings;
#endif
