/***************************************************************************
 *   Copyright (C) 2005 by s4kk3                                           *
 *   s4kk33@gmail.com                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SIDEBAR_H
#define SIDEBAR_H

#include "mainwindow.h"

class Sidebar
{
public:
	~Sidebar();
	
	static Sidebar *getInstance();

	void	createTreeView();
	void	createDragBoard();
	void	createBookmarks();

	void	 treeStoreScan			( std::string path,	GtkTreeRowReference *ref,	int depth );

	void	rowExpanded				( GtkTreeView *view,	GtkTreeIter *iter,	GtkTreePath *path,	gpointer data );

	void	treeViewActivated			( GtkTreeView *view,	GtkTreePath *path,	GtkTreeViewColumn *col,	gpointer data );

	void	treeViewSetPath			( std::string path );

	void	dragReceived				( GtkWidget *widget,	GdkDragContext *context,
				  				  int x,
				  				  int y,
				  				  GtkSelectionData *data,
				  				  guint info,
                           	  				  guint time,
                           	  				  gpointer user_data );

	void 	getDragData				( GtkWidget *widget,	GdkDragContext *context,
	       							  GtkSelectionData *selection_data,
	       							  guint info,
	       							  guint time,
	       							  gpointer data );

	void	loadBookmarks			();
	void	addBookmark				( std::string path );
	void	bookViewActivated			( GtkTreeView *view,	GtkTreePath *p,	GtkTreeViewColumn *col,	gpointer data );
	void addBookmarkClicked		( GtkWidget *widget,	gpointer data );
	void removeBookmarkClicked		( GtkWidget *widget,	gpointer data );
	
	void progressBarPush			()	const;

	GtkListStore	*boardStore;

protected:
	GtkWidget		*treeWindow,		*dragWindow,	*bookmarkWindow;
	GtkTreeView		*treeView,		*bookmarkView;
	GtkIconView		*boardView;
	GtkTreeStore		*treeStore;
	GtkListStore		*bookmarkStore;
	GtkProgressBar	*pBar;
	GtkBox			*treeViewBox;
	GtkButton		*addBookButton,	*removeBookButton;
	GtkEventBox		*dragEvent;

	GdkPixbuf			*directory;

	std::list<std::string> pathList;
	
	guint id;
	
	int calls;
	
	Func2<Sidebar, void, GtkWidget*> addBookmarkCallback,	removeBookmarkCallback;
	Func4<Sidebar, void, GtkTreeView*, GtkTreeIter *, GtkTreePath* > rowExpandedCallback;
	Func4<Sidebar, void, GtkTreeView*, GtkTreePath*, GtkTreeViewColumn* > treeViewActivatedCallback,	bookViewActivatedCallback;
   	Func6<Sidebar, void, GtkWidget *, GdkDragContext *, GtkSelectionData *, guint, guint> getDataCallback;
	Func8<Sidebar, void, GtkWidget *, GdkDragContext *, int, int, GtkSelectionData *, guint, guint> dragReceiveCallback;

private:
	Sidebar();
	static Sidebar *bar;
};
#else
class Sidebar;
#endif
