#include "terminal.h"

using namespace std;

//-------------------------------------------------------------------------
// constructor
Terminal::Terminal( string path,	bool needsTerminal,	string command )
{
	window	=	gtk_scrolled_window_new( false,	false );
	terminal	=	vte_terminal_new();
	gtk_scrolled_window_add_with_viewport( GTK_SCROLLED_WINDOW( window ),	terminal );
	gtk_scrolled_window_set_policy( GTK_SCROLLED_WINDOW( window ), 
					GTK_POLICY_AUTOMATIC,	GTK_POLICY_AUTOMATIC );
	
	vte_terminal_set_emulation( VTE_TERMINAL( terminal ),	"xterm" );
	
	string	cmd	=	MainWindow::getInstance()->getStringValue( "Values",	"loginShell" );
	
	vte_terminal_fork_command( VTE_TERMINAL( terminal ),	cmd.c_str(), 
								NULL,	NULL,	NULL,	FALSE,	FALSE,	FALSE);
	
	path	=	"cd "	+	path	+	( string )"\n";
	vte_terminal_feed_child( VTE_TERMINAL( terminal ),	path.c_str(),	path.size() );
	
	if( needsTerminal )
	{
		string	tmp	=	command	+	( string )"\n";
		vte_terminal_feed_child( VTE_TERMINAL( terminal ),	tmp.c_str(),	tmp.size() );
	}
}

//-------------------------------------------------------------------------
// destructor
Terminal::~Terminal()
{

}

//-------------------------------------------------------------------------
//// tabChanged method
void Terminal::tabChanged()	const
{
	MainWindow::getInstance()->setTerminalMode();
}

