/***************************************************************************
 *   Copyright (C) 2005 by s4kk3                                           *
 *   s4kk33@gmail.com                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef THEMEDOWNLOADER_HH
#define THEMEDOWNLOADER_HH

#include "mainwindow.h"

typedef struct
{
	std::string url;
	std::string name;
} DownloadData;

class ThemeDownloader
{
public:
	~ThemeDownloader();
	
	static	ThemeDownloader *getInstance();
	
	static void	*downloadThread		( void *arg );
	
	void 			download				( std::string url,	std::string name );
	void			createThemeView		();
	void			appendThemes		();
	void			themeSelectionChanged	( GtkTreeSelection *sel,	gpointer data );
	void			downloadClicked		( GtkWidget *widget,	gpointer data );
	void			closeClicked			( GtkWidget *widget,	gpointer data );
	void			onDestroyEvent		( GtkWidget *widget,	gpointer data );
	
protected:
	GtkWidget		*view,			*window;
	GtkTreeView		*themeView;
	GtkListStore		*themeStore;
	GtkImage			*preview;
	GtkLabel			*themeName,		*authorLabel,	*descriptionLabel,	*urlLabel,	*emailLabel;
	GtkProgressBar	*pBar;
	GtkButton		*closeButton,		*downloadButton;
	
	pthread_t thread;
	
	Func2<ThemeDownloader, void, GtkWidget *> downloadCallback,	closeCallback,	destroyCallback;
	Func2<ThemeDownloader, void, GtkTreeSelection*> selectionChangedCallback;
			
private:
	ThemeDownloader();
	static ThemeDownloader *themeDL;
};
#else
class ThemeDownloader;
#endif
