/***************************************************************************
 *   Copyright (C) 2005 by s4kk3                                           *
 *   s4kk33@gmail.com                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "thumbnail.h"

using namespace std;

Thumbnail *Thumbnail::thumb	=	NULL;
Thumbnail *Thumbnail::getInstance()
{
	if( !thumb )
		thumb	=	new	Thumbnail();
	return thumb;
}

//-------------------------------------------------------------------------
//// Constructor
Thumbnail::Thumbnail()
{
	thumb	=	this;
	thumbDir		=	g_get_home_dir() + (string)"/.gbrowser/thumbnails/";

	if( !g_file_test( thumbDir.c_str(),	G_FILE_TEST_EXISTS ) )
	{
		string cmd	=	"mkdir " + thumbDir;
		system( cmd.c_str() );
	}
}

//-------------------------------------------------------------------------
//// Destructor
Thumbnail::~Thumbnail()
{
}

//-------------------------------------------------------------------------
// getThumbnailFromDatabase method
GdkPixbuf *Thumbnail::getThumbnailFromDatabase( GtkListStore *store, GtkTreeIter iter, string path, int size )
{
	string name	=	g_path_get_basename( path.c_str() );
	
	GdkPixbuf *buf	=	this->getThumbnail( name,	size );

	if( !buf )
	{
		buf	=	this->getThumbnailAtSize( path,	size );
		this->saveThumbnailToFile( buf,	g_path_get_basename( path.c_str() ) );
	}

	return buf;
}

//-------------------------------------------------------------------------
//// getThumbnailAtSize method
GdkPixbuf *Thumbnail::getThumbnailAtSize( string path, int size )	const
{
	GdkPixbuf *buf	=	gdk_pixbuf_new_from_file_at_size( path.c_str(),
								  size,
								  size,
								  NULL );
	return buf;
}

//-------------------------------------------------------------------------
//// saveThumbnailToFile method
void Thumbnail::saveThumbnailToFile( GdkPixbuf *buf, string name )	const
{
	string output	=	thumbDir	+	name;

	gdk_pixbuf_save( buf,	output.c_str(),	"png",	NULL,	NULL );
}

//-------------------------------------------------------------------------
//// compareThumbnails method
bool Thumbnail::compareThumbnails( string originalFile,	string thumbFile, int size )
{
	GdkPixbuf *a	=	this->getThumbnailAtSize( originalFile,		size );
	GdkPixbuf *b	=	gdk_pixbuf_new_from_file( thumbFile.c_str(),	NULL );

	if( a != b )
		return false;
	return true;
}

//-------------------------------------------------------------------------
//// getThumbnail method
GdkPixbuf *Thumbnail::getThumbnail( string name, int size ) const
{
	string path     =       thumbDir + name;
	return this->getThumbnailAtSize( path,	size );
}
